#!/usr/bin/env python
# -*- coding: UTF8 -*-

#    pyLeech, downloads files listed in XML and HTML documents.
#    Copyright (C) 2008  Joakim Soderlund
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.


import os
import gtk
import urllib

from SimpleGladeApp import SimpleGladeApp
from SimpleGladeApp import bindtextdomain

from pyleech import pyLeech
from decimal import Decimal
from threading import Thread

__author__ = "Joakim Soderlund"
__version__ = "0.3"
__date__ = "2008-05-02"
__copyright__ = "Copyright (C) 2008  Joakim Soderlund"
__license__ = "GPLv3"

app_name = "pyleech"
app_version = "0.3"

glade_dir = ""
locale_dir = ""

bindtextdomain(app_name, locale_dir)
gtk.gdk.threads_init()

class leech(pyLeech):
	def __init__(self):
		pyLeech.__init__(self)

	def run(self):
		urls = plui.entry_url.get_text()
		types = plui.entry_types.get_text()
		target = plui.entry_target.get_text()
		
		self.data = []
		self.getURLs(urls, plui.checkbutton_links.get_active(), plui.checkbutton_images.get_active())
		self.filterURLs(types.split(" "))
		self.delDuplicates()
		self.dlURLs(target)

	def dlURLs(self, folder):
		completedDLs = 0
		for a in self.data:
			filename = a.split("/")[-1]
			fullpath = "%s/%s" % (folder, filename)
			if not os.path.exists(fullpath):
				plui.progressbar_file.set_fraction(0.0)
				plui.progressbar_file.set_text("Downloading %s..." % filename)
				urllib.urlretrieve(a, fullpath, self.progressBar)
				plui.progressbar_file.set_fraction(1.0)
			else:
				pass
			completedDLs += 1
			fraction = (Decimal(completedDLs)/Decimal(len(self.data)))
			plui.progressbar_total.set_fraction(fraction)
			plui.progressbar_total.set_text("%f" % (fraction * 100) + " percent completed.")


class Plui(SimpleGladeApp, Thread):
	"""GUI for pyLeech"""
	def __init__(self, path="pyleech.glade", root="plui", domain=app_name, **kwargs):
		path = os.path.join(glade_dir, path)
		SimpleGladeApp.__init__(self, path, root, domain, **kwargs)
		Thread.__init__(self)

	def new(self):
		print "A new %s has been created" % self.__class__.__name__

	def on_abort_clicked(self, widget, *args):
		gtk.main_quit()

	def on_download_clicked(self, widget, *args):
		self.leech = leech()
		self.leech.progressBar = self.progressBar
		self.leech.start()

	def on_plui_destroy(self, widget, *args):
		gtk.main_quit()

	def progressBar(self, progress, bytesize, target):
		self.progressbar_file.set_fraction(((Decimal(progress) * Decimal(bytesize))/Decimal(target)))

	def run(self):
		gtk.gdk.threads_enter()
		gtk.main()
		gtk.gdk.threads_leave()


class executor(Thread):
		def __init__(self):
			Thread.__init__(self)
			self.plui = Plui()
		
		def run(self):
			self.plui.start()
			print "hoooowdy how!"

if __name__ == "__main__":
#	main = executor()
#	main.run()
	plui = Plui()
	plui.start()
